'use strict';

exports.__esModule = true;
exports.SearchField = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _selectors = require('../store/selectors');

var filterSelectors = _interopRequireWildcard(_selectors);

var _FormatSize = require('@material-ui/icons/FormatSize');

var _FormatSize2 = _interopRequireDefault(_FormatSize);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Switch = require('@material-ui/core/Switch');

var _Switch2 = _interopRequireDefault(_Switch);

var _TextField = require('@material-ui/core/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Toolbar = require('@material-ui/core/Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _Tooltip = require('@material-ui/core/Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _materialUiPickers = require('material-ui-pickers');

var _Checkbox = require('@material-ui/core/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _FormGroup = require('@material-ui/core/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _FormControlLabel = require('@material-ui/core/FormControlLabel');

var _FormControlLabel2 = _interopRequireDefault(_FormControlLabel);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _FormLabel = require('@material-ui/core/FormLabel');

var _FormLabel2 = _interopRequireDefault(_FormLabel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SearchField = exports.SearchField = function SearchField(_ref) {
  var theme = _ref.theme,
      queryIndex = _ref.queryIndex,
      currentField = _ref.currentField,
      query = _ref.query,
      formatMessage = _ref.formatMessage,
      fields = _ref.fields,
      handleQueryChange = _ref.handleQueryChange,
      DateTimeFormat = _ref.DateTimeFormat,
      locale = _ref.locale,
      okLabel = _ref.okLabel,
      cancelLabel = _ref.cancelLabel;

  var _filterSelectors$sele = filterSelectors.selectQueryProps(query),
      value = _filterSelectors$sele.value,
      isCaseSensitive = _filterSelectors$sele.isCaseSensitive;

  if (queryIndex == null || currentField == null || query == null || handleQueryChange == null || fields == null) {
    return _react2.default.createElement('div', null);
  }

  var fieldType = '';
  var fieldLabel = '';
  var fieldData = [];

  fields.map(function (field) {
    if (field.name === currentField.value) {
      fieldType = field.type;
      fieldLabel = field.label;
      fieldData = field.data;
    }
    return field;
  });

  if (fieldType === 'enum') {
    return _react2.default.createElement(
      _Toolbar2.default,
      null,
      _react2.default.createElement(EnumList, { list: fieldData, handleQueryChange: handleQueryChange, queryIndex: queryIndex })
    );
  }

  if (fieldType === 'date') {
    return _react2.default.createElement(
      _Toolbar2.default,
      null,
      _react2.default.createElement(_materialUiPickers.DatePicker, {
        keyboard: true,
        label: formatMessage ? formatMessage({ id: 'enter_query_text' }) : '',
        format: 'DD/MM/YYYY',
        placeholder: '10/10/2018',
        mask: function mask(value) {
          return value ? [/\d/, /\d/, '/', /\d/, /\d/, '/', /\d/, /\d/, /\d/, /\d/] : [];
        },
        value: value,
        onChange: function onChange(val) {
          handleQueryChange(queryIndex, 'value', val.format());
        },
        disableOpenOnEnter: true,
        animateYearScrolling: false
      })
    );
  }

  if (fieldType === 'bool') {
    return _react2.default.createElement(
      _Toolbar2.default,
      null,
      _react2.default.createElement(_Switch2.default, {
        label: fieldLabel,
        onChange: function onChange(e, val) {
          handleQueryChange(queryIndex, 'value', val);
        },
        value: value
      })
    );
  } else {
    //string

    return _react2.default.createElement(
      _Toolbar2.default,
      null,
      _react2.default.createElement(_TextField2.default, {
        fullWidth: true,
        name: 'value',
        onChange: function onChange(e, val) {
          handleQueryChange(queryIndex, 'value', e.target.value);
        },
        value: value ? value : '',
        placeholder: formatMessage ? formatMessage({ id: 'enter_query_text' }) : ''
      }),
      _react2.default.createElement(
        _Tooltip2.default,
        {
          id: 'tooltip-bottom-start',
          title: formatMessage ? formatMessage({ id: isCaseSensitive ? 'disable_case_sensitivity' : 'enable_case_sensitivity' }) : '',
          placement: 'bottom-end'
        },
        _react2.default.createElement(
          _IconButton2.default,
          {
            onClick: function onClick() {
              handleQueryChange(queryIndex, 'isCaseSensitive', !isCaseSensitive);
            },
            color: isCaseSensitive ? 'primary' : undefined
          },
          _react2.default.createElement(_FormatSize2.default, null)
        )
      )
    );
  }
};

var EnumList = function (_Component) {
  _inherits(EnumList, _Component);

  function EnumList(props) {
    _classCallCheck(this, EnumList);

    // Don't call this.setState() here!
    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {};
    _this.handleChange = _this.handleChange.bind(_this);
    _this.capitalize = _this.capitalize.bind(_this);
    return _this;
  }

  EnumList.prototype.handleChange = function handleChange(event) {
    var _extends2, _setState;

    var _props = this.props,
        list = _props.list,
        handleQueryChange = _props.handleQueryChange,
        queryIndex = _props.queryIndex;


    var values = _extends({}, this.state, (_extends2 = {}, _extends2[event.target.value] = event.target.checked, _extends2));
    var vals = [];
    Object.keys(list).map(function (item) {
      var name = list[item];
      if (values[name]) {
        vals.push(name.toUpperCase());
      }
    });
    this.setState((_setState = {}, _setState[event.target.value] = event.target.checked, _setState));
    handleQueryChange(queryIndex, 'value', vals);
  };

  EnumList.prototype.capitalize = function capitalize(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
  };

  EnumList.prototype.componentWillMount = function componentWillMount() {
    var _this2 = this;

    var _props2 = this.props,
        list = _props2.list,
        handleQueryChange = _props2.handleQueryChange;

    var state = this.state;
    Object.keys(list).map(function (item, index) {
      var _extends3;

      var name = list[item];
      _this2.setState(_extends({}, state, (_extends3 = {}, _extends3[name] = true, _extends3)));
    });
  };

  EnumList.prototype.render = function render() {
    var _this3 = this;

    var list = this.props.list;


    return _react2.default.createElement(
      _FormControl2.default,
      { component: 'fieldset' },
      _react2.default.createElement(
        _FormGroup2.default,
        { 'aria-label': 'position', name: 'position', onChange: this.handleChange },
        Object.keys(list).map(function (item) {
          var name = list[item];
          return _react2.default.createElement(_FormControlLabel2.default, {
            key: name,
            value: name,
            control: _react2.default.createElement(_Checkbox2.default, { color: 'primary', checked: _this3.state[name] }),
            label: _this3.capitalize(name),
            labelPlacement: 'end'
          });
        })
      )
    );
  };

  return EnumList;
}(_react.Component);